#ifndef _DEFINES_
#define _DEFINES_

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <GL/glut.h>

#define INIT_W 512
#define INIT_H 512
#define PI 3.141592654
// body(1), neck(1), upper legs(12), lower legs(12)
#define NUMJOINTS 29

void myinit(void);
void myReshape(GLsizei, GLsizei);
void key(unsigned char, int, int);
void tdrect(GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
void bug(void);
void frontbody(void);
void backbody(void);

void movit(int);
void frontbody(void);
void legl(int);
void legr(int);
void bottomleg(int);
void neck(void);
void head(void);

void backbody(void);

void tiefigher(float);
void stardestroyer(float);
void tdrect(GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);

typedef struct materialStruct{			//from pg.124 in OpenGL primer
	GLfloat ambient[4];	
	GLfloat diffuse[4];
	GLfloat specular[4];
	GLfloat shininess;
}materialStruct;

void setMaterials(materialStruct *,GLint);

extern materialStruct redlaser;
extern materialStruct bluesolarpanels;
extern materialStruct gengrey;
extern materialStruct bluengines;
extern materialStruct Brass;
extern materialStruct Bronze;
extern materialStruct Polished_Bronze;
extern materialStruct Chrome;
extern materialStruct Copper;
extern materialStruct Polished_Copper;
extern materialStruct Gold;
extern materialStruct Polished_Gold;
extern materialStruct Pewter;
extern materialStruct Silver;
extern materialStruct Polished_Silver;
extern materialStruct Emerald;
extern materialStruct Jade;
extern materialStruct Obsidian;
extern materialStruct Pearl;
extern materialStruct Ruby;
extern materialStruct Turquoise;
extern materialStruct Black_Plastic;
extern materialStruct Black_Rubber;

#endif
