// Mark Kamichoff
// kamicm@rpi.edu
// Homework #4

#include "defines.h"

// globals
GLfloat win_width, win_height;
GLUquadricObj* gluObj;

// Joint rotation
int currentjoint=0;
int joints[NUMJOINTS][3];	// x, y, z for each joint

// Lights
int lite0 = -1;
int lite1 = -1;
int lite2 = -1;
int lite3 = -1;

// misc -1 is keyb, 1 is mouse
int howrotate = -1;

// View Stuff
int btempx, btempy, bktempx, bktempy, btemprotatespeed;
GLfloat tempx = 0.0;
GLfloat tempy = 0.0;
GLfloat ktempx = 5.0;
GLfloat ktempy = 5.0;
int drawstyle = 0;

// Joint moving stuff
int state_x, state_y, state_z;

// Main display function
void display(void)
{
	// Moves the whole scene
	if(bktempx == -1) ktempx--;
	if(bktempx == 1) ktempx++;
	if(bktempy == 1) ktempy++;
	if(bktempy == -1) ktempy--;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	// Mouse
	if(howrotate == 1)
	{
		glRotatef(tempx, 0.0, 1.0, 0.0);
		glRotatef(tempy, 1.0, 0.0, 0.0);
	}
	// Keyboard
	else
	{
		glRotatef(ktempx, 0.0, 1.0, 0.0);
		glRotatef(ktempy, 1.0, 0.0, 0.0);
	}

	// The joint
	if(state_x == 1) joints[currentjoint][0] += 1;
	if(state_x == -1) joints[currentjoint][0] -= 1;
	if(state_y == 1) joints[currentjoint][1] += 1;
	if(state_y == -1) joints[currentjoint][1] -= 1;
	if(state_z == 1) joints[currentjoint][2] += 1;
	if(state_z == -1) joints[currentjoint][2] -= 1;

//	glPushMatrix();
		bug();
//	glPopMatrix();

	glutSwapBuffers();
}

// generic resize function, scales to W x H
void myReshape(GLsizei w, GLsizei h)
{
	win_width = w;
	win_height = h;

	glViewport(0,0,win_width,win_height);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-1.0, 1.0, -1.0, 1.0, -10.0, 10.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glClearColor(0.0, 0.0, 0.0,0.0);
	glClear(GL_COLOR_BUFFER_BIT);

	display();
	glutSwapBuffers();
}

// generic initialization routine
void myinit(void)
{
	int i,j;

	GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0 };
	GLfloat mat_shininess[] = { 8.0 };

	// Set up all the light properties and positions
	GLfloat light0_ambient[] = { 1.0, 1.0, 1.0, 1.0 };
	GLfloat light0_position[] = { 0.0, 1.0, 0.0, 0.0 };

	GLfloat light1_ambient[] = { 0.0, 0.0, 1.0, 1.0 };
	GLfloat light1_position[] = { 1.0, 0.0, 0.0, 0.0 };
	GLfloat light1_diffuse[] = { 0.0, 0.0, 1.0, 1.0 };

	GLfloat light2_ambient[] = { 1.0, 0.0, 0.0, 1.0 };
	GLfloat light2_position[] = { -1.0, 0.0, 0.0, 0.0 };
	GLfloat light2_diffuse[] = { 1.0, 0.0, 0.0, 1.0 };

	GLfloat light3_ambient[] = { 0.0, 1.0, 0.0, 1.0 };
	GLfloat light3_position[] = { 0.0, -1.0, 0.0, 0.0 };
	GLfloat light3_diffuse[] = { 0.0, 1.0, 0.0, 1.0 };

	// Init the legs rotational variable
	for(i=0;i<NUMJOINTS;i++)
		for(j=0;j<3;j++)
			joints[i][j]=0;

	// Make a new quadric object which we will use
	gluObj = gluNewQuadric();

	glClearColor(0.0, 0.0, 0.0, 0.0);
	glShadeModel(GL_SMOOTH);
	
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);

	// Apply the properties to the lights
	glLightfv(GL_LIGHT0, GL_AMBIENT, light0_ambient);
	glLightfv(GL_LIGHT0, GL_POSITION, light0_position);

	glLightfv(GL_LIGHT1, GL_AMBIENT, light1_ambient);
	glLightfv(GL_LIGHT1, GL_POSITION, light1_position);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, light1_diffuse);
	glLightfv(GL_LIGHT2, GL_AMBIENT, light2_ambient);
	glLightfv(GL_LIGHT2, GL_POSITION, light2_position);
	glLightfv(GL_LIGHT2, GL_DIFFUSE, light2_diffuse);
	glLightfv(GL_LIGHT3, GL_AMBIENT, light3_ambient);
	glLightfv(GL_LIGHT3, GL_POSITION, light3_position);
	glLightfv(GL_LIGHT3, GL_DIFFUSE, light3_diffuse);

	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);

	glutSwapBuffers();
}

void root_menu(int id)
{
	// Dummy Function
	if(id == 1)
		exit(0);
}

// If we type a key on the keyboad
void key(unsigned char k, int x, int y)
{
	int i,j;

	// Keybindings
	if(k == 'q') exit(0);
	if(k == 'r') howrotate *= -1;

	// Cycles through filled, wire, and point drawstyles
	if(k == 'p')
	{
		if(drawstyle < 2) drawstyle++;
		else drawstyle=0;

		if(!drawstyle)
			glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
		else if(drawstyle == 1)
			glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
		else if(drawstyle == 2)
			glPolygonMode(GL_FRONT_AND_BACK, GL_POINT);
	}

	// Manage the joint movement
	if(k == 'h') state_x = -1;
	if(k == 'l') state_x = 1;

	if(k == 'j') state_y = -1;
	if(k == 'k') state_y = 1;

	if(k == 'z') state_z = -1;
	if(k == 'a') state_z = 1;

	// Resets the bug if 0 is pressed
	if(k == '0')
	{
		for(i=0;i<NUMJOINTS;i++)
			for(j=0;j<3;j++)
				joints[i][j]=0;
	}

	// Resets the keyboard view if 'v' is pressed
	if(k == 'v')
		ktempx=ktempy=0;
}

// Keybindings for ones that turn off when unpressed
void keyup(unsigned char k, int x, int y)
{
	// Keybindings up

	// Manage joint movement[rotate off]
	if(k == 'h') state_x = 0;
	if(k == 'l') state_x = 0;

	if(k == 'j') state_y = 0;
	if(k == 'k') state_y = 0;

	if(k == 'z') state_z = 0;
	if(k == 'a') state_z = 0;
}

// special keys
void skey(unsigned char k, int x, int y)
{
	// Manage the single part movement
	if(k == GLUT_KEY_PAGE_UP)
	{
		if(currentjoint >= (NUMJOINTS-1))
			currentjoint = 0;
		else
			currentjoint++;
	}
	else if(k == GLUT_KEY_PAGE_DOWN)
	{
		if(currentjoint <= 0)
			currentjoint = NUMJOINTS-1;
		else
			currentjoint--;
	}

	// Manage the whole rotation
	if(k == GLUT_KEY_LEFT) bktempx = -1;
	if(k == GLUT_KEY_RIGHT) bktempx = 1;
	if(k == GLUT_KEY_UP) bktempy = 1;
	if(k == GLUT_KEY_DOWN) bktempy = -1;

	// bunch of Fx keys toggle lights
	if(k == GLUT_KEY_F1)	// white
	{
		if(lite0 == 1)
		{
			glDisable(GL_LIGHT0);
			lite0 *= -1;
		}
		else
		{
			glEnable(GL_LIGHT0);
			lite0 *= -1;
		}
	}
	if(k == GLUT_KEY_F2)
	{
		if(lite1 == 1)
		{
			glDisable(GL_LIGHT1);
			lite1 *= -1;
		}
		else
		{
			glEnable(GL_LIGHT1);
			lite1 *= -1;
		}
	}
	if(k == GLUT_KEY_F3)
	{
		if(lite2 == 1)
		{
			glDisable(GL_LIGHT2);
			lite2 *= -1;
		}
		else
		{
			glEnable(GL_LIGHT2);
			lite2 *= -1;
		}
	}
	if(k == GLUT_KEY_F4)
	{
		if(lite3 == 1)
		{
			glDisable(GL_LIGHT3);
			lite3 *= -1;
		}
		else
		{
			glEnable(GL_LIGHT3);
			lite3 *= -1;
		}
	}
}

// Up versions of the above bindings
void skeyup(unsigned char k, int x, int y)
{
	if(k == GLUT_KEY_LEFT) bktempx = 0;
	if(k == GLUT_KEY_RIGHT) bktempx = 0;
	if(k == GLUT_KEY_UP) bktempy = 0;
	if(k == GLUT_KEY_DOWN) bktempy = 0;
}

// Passive mouse...same as in last project
void mouse_passive(int x, int y)
{
	y = win_height - y;

	tempx = x;
	tempy = y;
}

// Main function
int main(int argc, char **argv)
{
	// Sets the global h/w
	win_width = INIT_W;
	win_height = INIT_H;
		
	// GLUT stuff and create the menus
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize(INIT_W, INIT_H);
	glutCreateWindow("Prox Bug");

	glutDisplayFunc(display);
	glutIdleFunc(display);

	glutCreateMenu(root_menu);
	glutCreateMenu(root_menu);
	glutAddMenuEntry("Exits", 1);

	// right click for the menu
	glutAttachMenu(GLUT_RIGHT_BUTTON);

	myinit();

	glutReshapeFunc(myReshape);

	glutIgnoreKeyRepeat(1);
	glutKeyboardFunc(key);
	glutKeyboardUpFunc(keyup);
	glutSpecialFunc((void *)skey);
	glutSpecialUpFunc((void *)skeyup);
	glutPassiveMotionFunc(mouse_passive);

	glutMainLoop();

	return 0;
}
